package dev.peerat.backend.routes.admins.tag;

import static dev.peerat.framework.RequestType.PUT;

import java.util.regex.Matcher;

import dev.peerat.backend.model.Tag;
import dev.peerat.backend.repository.DatabaseRepository;
import dev.peerat.framework.Context;
import dev.peerat.framework.HttpReader;
import dev.peerat.framework.HttpWriter;
import dev.peerat.framework.Response;
import dev.peerat.framework.Route;
import dev.peerat.framework.utils.json.JsonMap;

public class EditTag implements Response{
	
	private DatabaseRepository repo;
	
	public EditTag(DatabaseRepository repo){
		this.repo = repo;
	}
	
	@Route(path = "^/admin/tag/(\\d+)$", type = PUT, needLogin = true)
	public void exec(Matcher matcher, Context context, HttpReader reader, HttpWriter writer) throws Exception{
		JsonMap json = reader.readJson();
		if(repo.adminUpdateTag(new Tag(Integer.parseInt(matcher.group(1)), json.get("name")))){
			context.response(200);
		}else{
			context.response(501);
		}
	}

}
